#include <stdio.h>
#include <string.h>

// apt-get install libpwquality-dev
#include <pwquality.h>

int main(int argc, char* argv[])
{
    int result = 0;
    if (argc != 4 && argc != 3) {
        result = 100;
        printf("%d\n%s [$configfile] $username $password\n", result, argv[0]);
        return result;
    }

    char error[256];
    memset(error, 0, sizeof(error));
    
    pwquality_settings_t* pwqs = pwquality_default_settings();
    if (argc == 4) {
        int err_cfg = pwquality_read_config(pwqs, argv[1], 0);
        if (err_cfg != 0) {
            printf("%d\n%s\n", err_cfg, pwquality_strerror(error, sizeof(error), err_cfg, 0));
            result = err_cfg;
            goto EOP;
        }
    }

    int err_check = pwquality_check(pwqs, argv[argc-1], 0, argv[argc-2], 0);
    if (err_check < 0) {
        printf("%d\n%s\n", err_check, pwquality_strerror(error, sizeof(error), err_check, 0));
        result = err_check;
    } else {
        printf("0\npassword and user pair ok, with entropy %d :)\n", err_check);
    }

EOP:
    pwquality_free_settings(pwqs);
    return result;
}
